<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryRef" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="物资ID" prop="materialId">
        <el-input
          v-model="queryParams.materialId"
          placeholder="请输入物资ID"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item label="属性名称" prop="attributeName">
        <el-input
          v-model="queryParams.attributeName"
          placeholder="请输入属性名称"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item label="属性编码" prop="attributeCode">
        <el-input
          v-model="queryParams.attributeCode"
          placeholder="请输入属性编码"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item label="排序" prop="sortOrder">
        <el-input
          v-model="queryParams.sortOrder"
          placeholder="请输入排序"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
        <el-button icon="Refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="Plus"
          @click="handleAdd"
          v-hasPermi="['ware:wmsMaterialAttribute:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="Edit"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['ware:wmsMaterialAttribute:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="Delete"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['ware:wmsMaterialAttribute:remove']"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="Download"
          @click="handleExport"
          v-hasPermi="['ware:wmsMaterialAttribute:export']"
        >导出</el-button>
      </el-col>
      <right-toolbar v-model:showSearch="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="wmsMaterialAttributeList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="属性ID" align="center" prop="attributeId" />
      <el-table-column label="物资ID" align="center" prop="materialId" />
      <el-table-column label="属性名称" align="center" prop="attributeName" />
      <el-table-column label="属性编码" align="center" prop="attributeCode" />
      <el-table-column label="属性值" align="center" prop="attributeValue" />
      <el-table-column label="属性类型" align="center" prop="attributeType" />
      <el-table-column label="排序" align="center" prop="sortOrder" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template #default="scope">
          <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)" v-hasPermi="['ware:wmsMaterialAttribute:edit']">修改</el-button>
          <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)" v-hasPermi="['ware:wmsMaterialAttribute:remove']">删除</el-button>
        </template>
      </el-table-column>
    </el-table>
    
    <pagination
      v-show="total>0"
      :total="total"
      v-model:page="queryParams.pageNum"
      v-model:limit="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改物资属性对话框 -->
    <el-dialog :title="title" v-model="open" width="500px" append-to-body>
      <el-form ref="wmsMaterialAttributeRef" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="物资ID" prop="materialId">
          <el-input v-model="form.materialId" placeholder="请输入物资ID" />
        </el-form-item>
        <el-form-item label="属性名称" prop="attributeName">
          <el-input v-model="form.attributeName" placeholder="请输入属性名称" />
        </el-form-item>
        <el-form-item label="属性编码" prop="attributeCode">
          <el-input v-model="form.attributeCode" placeholder="请输入属性编码" />
        </el-form-item>
        <el-form-item label="属性值" prop="attributeValue">
          <el-input v-model="form.attributeValue" type="textarea" placeholder="请输入内容" />
        </el-form-item>
        <el-form-item label="排序" prop="sortOrder">
          <el-input v-model="form.sortOrder" placeholder="请输入排序" />
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="WmsMaterialAttribute">
import { listWmsMaterialAttribute, getWmsMaterialAttribute, delWmsMaterialAttribute, addWmsMaterialAttribute, updateWmsMaterialAttribute } from "@/api/ware/wmsMaterialAttribute"

const { proxy } = getCurrentInstance()

const wmsMaterialAttributeList = ref([])
const open = ref(false)
const loading = ref(true)
const showSearch = ref(true)
const ids = ref([])
const single = ref(true)
const multiple = ref(true)
const total = ref(0)
const title = ref("")

const data = reactive({
  form: {},
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    materialId: null,
    attributeName: null,
    attributeCode: null,
    attributeValue: null,
    attributeType: null,
    sortOrder: null,
  },
  rules: {
    materialId: [
      { required: true, message: "物资ID不能为空", trigger: "blur" }
    ],
    attributeName: [
      { required: true, message: "属性名称不能为空", trigger: "blur" }
    ],
    attributeCode: [
      { required: true, message: "属性编码不能为空", trigger: "blur" }
    ],
  }
})

const { queryParams, form, rules } = toRefs(data)

/** 查询物资属性列表 */
function getList() {
  loading.value = true
  listWmsMaterialAttribute(queryParams.value).then(response => {
    wmsMaterialAttributeList.value = response.rows
    total.value = response.total
    loading.value = false
  })
}

// 取消按钮
function cancel() {
  open.value = false
  reset()
}

// 表单重置
function reset() {
  form.value = {
    attributeId: null,
    materialId: null,
    attributeName: null,
    attributeCode: null,
    attributeValue: null,
    attributeType: null,
    sortOrder: null,
    createBy: null,
    createTime: null,
    updateBy: null,
    updateTime: null
  }
  proxy.resetForm("wmsMaterialAttributeRef")
}

/** 搜索按钮操作 */
function handleQuery() {
  queryParams.value.pageNum = 1
  getList()
}

/** 重置按钮操作 */
function resetQuery() {
  proxy.resetForm("queryRef")
  handleQuery()
}

// 多选框选中数据
function handleSelectionChange(selection) {
  ids.value = selection.map(item => item.attributeId)
  single.value = selection.length != 1
  multiple.value = !selection.length
}

/** 新增按钮操作 */
function handleAdd() {
  reset()
  open.value = true
  title.value = "添加物资属性"
}

/** 修改按钮操作 */
function handleUpdate(row) {
  reset()
  const _attributeId = row.attributeId || ids.value
  getWmsMaterialAttribute(_attributeId).then(response => {
    form.value = response.data
    open.value = true
    title.value = "修改物资属性"
  })
}

/** 提交按钮 */
function submitForm() {
  proxy.$refs["wmsMaterialAttributeRef"].validate(valid => {
    if (valid) {
      if (form.value.attributeId != null) {
        updateWmsMaterialAttribute(form.value).then(response => {
          proxy.$modal.msgSuccess("修改成功")
          open.value = false
          getList()
        })
      } else {
        addWmsMaterialAttribute(form.value).then(response => {
          proxy.$modal.msgSuccess("新增成功")
          open.value = false
          getList()
        })
      }
    }
  })
}

/** 删除按钮操作 */
function handleDelete(row) {
  const _attributeIds = row.attributeId || ids.value
  proxy.$modal.confirm('是否确认删除物资属性编号为"' + _attributeIds + '"的数据项？').then(function() {
    return delWmsMaterialAttribute(_attributeIds)
  }).then(() => {
    getList()
    proxy.$modal.msgSuccess("删除成功")
  }).catch(() => {})
}

/** 导出按钮操作 */
function handleExport() {
  proxy.download('ware/wmsMaterialAttribute/export', {
    ...queryParams.value
  }, `wmsMaterialAttribute_${new Date().getTime()}.xlsx`)
}

getList()
</script>
